
/****** Object : Table [dbo].[Winsock] Copyright TECK SYSTEM SOFT 2024 One ******/

UPDATE [Monitorpack_GuardReportsMonitorpack].[dbo].[Winsock] SET [Insert_Date] = '' WHERE [Insert_Date] IS NULL
UPDATE [Monitorpack_GuardReportsMonitorpack].[dbo].[Winsock] SET [Customer] = '' WHERE [Customer] IS NULL
UPDATE [Monitorpack_GuardReportsMonitorpack].[dbo].[Winsock] SET [Site] = '' WHERE [Site] IS NULL
UPDATE [Monitorpack_GuardReportsMonitorpack].[dbo].[Winsock] SET [Manager] = '' WHERE [Manager] IS NULL
UPDATE [Monitorpack_GuardReportsMonitorpack].[dbo].[Winsock] SET [Severity] = '' WHERE [Severity] IS NULL
UPDATE [Monitorpack_GuardReportsMonitorpack].[dbo].[Winsock] SET [Dashboard] = '' WHERE [Dashboard] IS NULL
UPDATE [Monitorpack_GuardReportsMonitorpack].[dbo].[Winsock] SET [Domain] = '' WHERE [Domain] IS NULL
UPDATE [Monitorpack_GuardReportsMonitorpack].[dbo].[Winsock] SET [Computer] = '' WHERE [Computer] IS NULL
UPDATE [Monitorpack_GuardReportsMonitorpack].[dbo].[Winsock] SET [Port] = '' WHERE [Port] IS NULL
UPDATE [Monitorpack_GuardReportsMonitorpack].[dbo].[Winsock] SET [Status] = '' WHERE [Status] IS NULL
UPDATE [Monitorpack_GuardReportsMonitorpack].[dbo].[Winsock] SET [Mode] = '' WHERE [Mode] IS NULL
UPDATE [Monitorpack_GuardReportsMonitorpack].[dbo].[Winsock] SET [Alarm] = '' WHERE [Alarm] IS NULL
UPDATE [Monitorpack_GuardReportsMonitorpack].[dbo].[Winsock] SET [Availability] = '' WHERE [Availability] IS NULL

INSERT INTO [Monitorpack_GuardReportsMonitorpack].[dbo].[AvailabilityWinsock]
([Insert_Date]
      ,[Customer]
      ,[Site]
      ,[Manager]
      ,[Severity]
      ,[Dashboard]
      ,[Domain]
      ,[Computer]
      ,[Port]
      ,[Status] 
      ,[Mode] 
      ,[Alarm]
      ,[Availability]
)

SELECT  
[Insert_Date]
      ,[Customer]
      ,[Site]
      ,[Manager]
      ,[Severity]
      ,[Dashboard]
      ,[Domain] 
      ,[Computer]
      ,[Port]
      ,[Status] 
      ,[Mode] 
      ,[Alarm]
      ,CONVERT(nvarchar(10),[Availability])

FROM

(SELECT DISTINCT  CONVERT(nvarchar(25),[Insert_Date]) + '-' + [Customer] + '-' + [Site] + '-' + [Domain] + '-' + [Computer] + '-' + [Port] +  '-' + [Status] + '-' + [Alarm] + '-' + CONVERT(nvarchar(10),[Availability])  AS SEARCH_STRING
	  ,[Insert_Date]
      ,[Customer]
      ,[Site]
      ,[Manager]
      ,[Severity]
      ,[Dashboard]
      ,[Domain]
      ,[Computer]
      ,[Port] /*= [Computer] + ':' + [Port]*/
      ,[Status] 
      ,[Mode]
      ,[Alarm]
      ,[Availability]  

FROM [Monitorpack_GuardReportsMonitorpack].[dbo].[Winsock]
WHERE [Availability] = '1' AND CONVERT(nvarchar(25),[Insert_Date]) + '-' + [Customer] + '-' + [Site] + '-' + [Domain] + '-' + [Computer] + '-' + [Port] +  '-' + [Status] + '-' + [Alarm] + '-' + CONVERT(nvarchar(10),[Availability])  NOT IN 

(SELECT DISTINCT CONVERT(nvarchar(25),[Insert_Date]) + '-' +  [Customer] + '-' + [Site] + '-' + [Domain] + '-' + [Computer] + '-' + [Port] +  '-' + [Status] + '-' + [Alarm] + '-' + CONVERT(nvarchar(10),[Availability])  as SEARCH_STRING 
FROM [Monitorpack_GuardReportsMonitorpack].[dbo].[AvailabilityWinsock]) ) TBL 

/****** Object : UPDATE existing entries with the lastest values ******/

UPDATE [Monitorpack_GuardReportsMonitorpack].[dbo].[AvailabilityWinsock] 
SET  [Status] = REQUEST.[Status],
     [Alarm] = REQUEST.[Alarm],
     [Availability] = REQUEST.[Availability]
     /* [Insert_Date] = REQUEST.[Insert_Date] -- Last UPDATE time */

FROM [Monitorpack_GuardReportsMonitorpack].[dbo].[AvailabilityWinsock] SOCKS,

/****** Object : Select values ******/

(SELECT TEMP_JOIN.[Socket_ID],
TEMP_JOIN.[Insert_Date],
TEMP_JOIN.[Customer],
TEMP_JOIN.[Site],
TEMP_JOIN.[Domain],
TEMP_JOIN.[Computer],
TEMP_JOIN.[Port],
TEMP_JOIN.[Mode],
TEMP_JOIN.[Status],
TEMP_JOIN.[Alarm],
TEMP_JOIN.[Availability]

FROM [Monitorpack_GuardReportsMonitorpack].[dbo].[Winsock] TEMP
INNER JOIN  [Monitorpack_GuardReportsMonitorpack].[dbo].[Winsock] TEMP_JOIN 
ON TEMP_JOIN.[Mode] = TEMP.[Mode]

WHERE
TEMP.[Customer] = TEMP_JOIN .[Customer] AND
TEMP.[Site] = TEMP_JOIN .[Site] AND 
TEMP.[Domain] = TEMP_JOIN .[Domain] AND
TEMP.[Computer] = TEMP_JOIN .[Computer] AND
TEMP.[Port] =  TEMP_JOIN .[Port] AND
TEMP.[Mode] = TEMP_JOIN .[Mode] AND
TEMP.[Status] = TEMP_JOIN .[Status] AND
TEMP.[Availability]=TEMP_JOIN.[Availability]

GROUP BY
TEMP_JOIN.[Socket_ID],
TEMP_JOIN.[Insert_Date],
TEMP_JOIN.[Customer],
TEMP_JOIN.[Site],
TEMP_JOIN.[Domain],
TEMP_JOIN.[Computer],
TEMP_JOIN.[Port],
TEMP_JOIN.[Mode],
TEMP_JOIN.[Status],
TEMP_JOIN.[Alarm],
TEMP_JOIN.[Availability]

HAVING max(TEMP.Socket_ID) = TEMP_JOIN.[Socket_ID]) AS REQUEST

WHERE
SOCKS.[Customer] = REQUEST.[Customer]
AND SOCKS.[Site] = REQUEST.[Site]
AND SOCKS.[Domain] = REQUEST.[Domain]
AND SOCKS.[Computer] = REQUEST.[Computer]
AND SOCKS.[Alarm] = REQUEST.[Alarm]
AND SOCKS.[Status] = REQUEST.[Status]
AND SOCKS.[Availability] = REQUEST.[Availability]
   
TRUNCATE TABLE [Monitorpack_GuardReportsMonitorpack].[dbo].[WinsockTemp] 